import java.io.FileInputStream;
import java.security.KeyStore;
import java.security.Key;
import java.security.PublicKey;
import java.security.PrivateKey;
import java.security.KeyPair;
import java.security.Signature;
import java.security.cert.Certificate;
import sun.misc.BASE64Encoder;

public class Sign {

  static public void main(String[] args) throws Exception {
    byte[] data = args[0].getBytes("UTF8");
    FileInputStream is = new FileInputStream("server.pkcs12");
    KeyStore keystore = KeyStore.getInstance("pkcs12");
    keystore.load(is, "Kiosko_00".toCharArray());
    Key key = keystore.getKey("testsign", "Kiosko_00".toCharArray());
    Certificate cert = keystore.getCertificate("testsign");
    PublicKey publicKey = cert.getPublicKey();
    KeyPair keyPair = new KeyPair(publicKey, (PrivateKey) key);
    Signature sig = Signature.getInstance("SHA256withRSA");
    sig.initSign(keyPair.getPrivate());
    sig.update(data);
    byte[] signatureBytes = sig.sign();
    System.out.println("Singature:" + new BASE64Encoder().encode(signatureBytes));
    //FileOutputStream out = new FileOutputStream("simple-text.sig");
    //out.write(signatureBytes);
    sig.initVerify(keyPair.getPublic());
    sig.update(data);
    System.out.println("Is signature OK? " + sig.verify(signatureBytes));
    //out.close();
    is.close();
  }

}
